"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @Author: your name
 * @Date: 2020-05-26 17:04:14
 * @LastEditTime: 2020-05-27 13:56:12
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /sails-model-generator/src/FeatureUtils.ts
 */
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const colors_1 = __importDefault(require("colors"));
let FeatureUtils = /** @class */ (() => {
    class FeatureUtils {
        /**
         * 添加功能模块
         * @param name 功能模块的名称
         */
        static addFeature(name) {
            if (FeatureUtils.features[name]) {
                let feature = FeatureUtils.features[name];
                feature.generate();
            }
            else {
                console.log(colors_1.default.error(`不存在功能“${name}”，请检查输入是否正确`));
            }
        }
        /**
         * 打印所有的功能模块
         */
        static printFeatures() {
            console.table(this.feature_desc);
        }
        /**
         * 自动将feature注册到系统中
         */
        static autoLink() {
            let features_dir = path_1.default.join(__dirname, 'features');
            let files = fs_extra_1.default.readdirSync(features_dir);
            for (let filename of files) {
                let file = path_1.default.join(features_dir, filename);
                let basename = path_1.default.basename(file, '.js');
                let Feature = require(`./features/${basename}`).default;
                let feature = new Feature();
                if (feature.name && feature.name()) {
                    FeatureUtils.features[feature.name()] = feature;
                    FeatureUtils.feature_desc.push({
                        name: feature.name(),
                        desc: feature.desc()
                    });
                }
            }
        }
    }
    FeatureUtils.features = {};
    FeatureUtils.feature_desc = [];
    return FeatureUtils;
})();
exports.default = FeatureUtils;
